<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: breadcrumb.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: breadcrumb.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>import { LitElement, css, html } from "lit-element"
import { Tooltip } from "bootstrap"

/** 
 * Generate a breadcrumb component given a path object with root item, main menu items and right hand menu items
 * @extends LitElement
 */
export class OnisBreadcrumb extends LitElement {
  
  /** 
   * Identifier for this component
   */
  static get is() {
    return "onis-breadcrumb"
  }

  /** Define propperties for the component*/
  static get properties() {
    return {
      props: {type: Object}
    }
  }

  /** Default constructor 
   * @constructor
  */
  constructor() {
    super()
    this.props = {}
  }

  /** Modifies the props object and updates the component with the requestUpdate(..) function
   * @param {object} val - object with values for root, path and rightMenu
  */
  set props(val) {
    let oldVal = this._props;
    this._props = val
    this.requestUpdate('props', oldVal)
  }

  /** Accesor for the props object
   * @returns props object for the component
   */
  get props(){return this._props}

  /**
   * @returns root component for the render
   */
  createRenderRoot() {
    return this
  }

  /**
   * Renders the component
   */
  render() {
    return html`
      &lt;nav aria-label="breadcrumb">
        &lt;ol class="breadcrumb text-info mb-0 pl-1">
          &lt;li class="ml-0 pl-0 pr-3">&lt;a class="text-decoration-none" target="top" href="${this.props.root.url?this.props.root.url:'#'}">&lt;img width=24 height=24 src="${this.props.root.icon?this.props.root.icon:''}" title="${this.props.root.title}" >&lt;/a>&lt;/li>
          ${this.props.path.length == 0 ? html`&amp;nbsp;` : this.props.path.map((v, i, a) => {
            if (v.items) {
              return html`&lt;li style="cursor:pointer" class="breadcrumb-item dropdown">
                &lt;a class="text-decoration-none" href="${v.items[0].url}" title="${v.items[0].tooltip?v.items[0].tooltip:''}">&lt;i class="${v.iconClass} mr-1 mt-1" aria-hidden="true">&lt;/i>&lt;/a>
                &lt;a id="dmb" class="dropdown-toggle text-decoration-none ${i==a.length-1?'active font-weight-bold':''}"
                  data-toggle="dropdown">${v.label}&lt;/a>
                &lt;ul class="dropdown-menu" aria-labelledby="dmb">
                  ${v.items.map(iv => html`&lt;li>&lt;a class="dropdown-item" href="${iv.url}" title="${iv.tooltip?iv.tooltip:''}">${OnisBreadcrumb._getItemLabel(iv)}&lt;/a>&lt;/li>`)}
                &lt;/ul>
              &lt;/li>`
            }
            return html`&lt;li class="breadcrumb-item" data-toggle="${v.tooltip?'tooltip':''}"
              data-placement="bottom" title="${v.tooltip?v.tooltip:''}">
              &lt;a class="text-decoration-none ${i==a.length-1?'active font-weight-bold':''}" target="${v.target?v.target:"_self"}" href="${v.url}">&lt;i class="${v.iconClass} mr-1 mt-1" aria-hidden="true">&lt;/i>${v.label}&lt;/a>
            &lt;/li>`
          })}
          ${this.props.rightMenu == undefined ? html`&amp;nbsp;` : this.props.rightMenu.map((v, i, a) => { 
            return v.items ? 
            html `&lt;ul class="navbar-nav ${0==i?'ml-auto':'ml-2'}">
                    &lt;li class="nav-item dropdown">
                      &lt;a class="nav-link dropdown-toggle ml-1 pt-0 pb-0 mb-0" href="#" id="bcNavbarDropdownMenuLink" data-toggle="dropdown"
                        aria-haspopup="true" aria-expanded="false">
                        &lt;i class="${v.iconClass}" aria-hidden="true">&lt;/i>
                      &lt;/a>
                      &lt;ul class="dropdown-menu" aria-labelledby="bcNavbarDropdownMenuLink">
                      ${v.items.map(iv => iv.type == 'divider' ? 
                          html `&lt;li>&lt;hr class="dropdown-divider">&lt;/li>`: 
                          html`&lt;li>&lt;a class="dropdown-item" target="${iv.target?iv.target:''}" href="${iv.url}">&lt;i class="${iv.iconClass}" aria-hidden="true">&lt;/i> ${iv.label}&lt;/a>&lt;/li>`
                      )}
                      &lt;/ul>
                    &lt;/li>
                  &lt;/ul>` :
            html `&lt;li class="${0==i?'ml-auto':'ml-2'}">&lt;a class="text-decoration-none" target="${v.target?v.target:'_self'}" href="${v.url}">&lt;i class="${v.iconClass}">&lt;/i>&lt;/a>&lt;/li>`
          })}
        &lt;/ol>
      &lt;/nav>`
  }

  /**
   * Returns renderable state of a given menu item
   * @param {object} i - instance of the menu item 
   */
  static _getItemLabel(i) {
    if (i.active) {
      return html`&lt;b>${i.label}&lt;/b>`
    }
    return i.label
  }

  /**
   * Once the component is created, add the tooltip to sub-elements
   */
  updated() {
    for (let e of this.firstElementChild.querySelectorAll('[data-toggle="tooltip"]')) {
      new Tooltip(e)
    }
  }
}

/** Register the created custom element */
customElements.define(OnisBreadcrumb.is, OnisBreadcrumb)
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Classes</h3><ul><li><a href="OnisBreadcrumb.html">OnisBreadcrumb</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.6</a> on Tue Feb 16 2021 23:02:50 GMT+0000 (Greenwich Mean Time)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
